function A_inter = my_interp(A, filter_coef)
if (length(size(A)) == 3)
    for i=1:3
        A_inter(:,:,i) = my_interp(A(:,:,i),filter_coef);
    end
    
else
    
    [m,n] = size(A);
    A_ = []; A_inter = [];
    % columns interpolation
    A_col= filter2(filter_coef,A);
    for i=1:n
        A_ = [A_ A(:,i) A_col(:,i)];
    end
    A_(:,end) = [];
    % rows interpolation
    A_rows = filter2(filter_coef,A_')';
    for i=1:m
        A_inter = [A_inter; A_(i,:); A_rows(i,:)];
    end
    A_inter(end,:) = [];
    
end